#!/bin/bash

FULLY_MANAGED="complete";
MANAGED="basic";
LOG_FILE=${LOG_FILE:-'managed_servers.log'}
#-----------------------------
function write_log() {
echo -e "$(date +'%Y-%m-%d %T %z') $(hostname) [alert_fixer]:" $(echo "$*") | tee -a "/root/$LOG_FILE"
}
#-----------------------------
function check_exit() {
if [[ "$1" == "ex" ]]; then
    shift; local EXIT_FLAG=1
fi
eval "$@" &>/dev/null;
if [ $? -ne 0 ]; then
    write_log "$@";
    eval "$@" 2>&1 | sed '1s/^/[log_start:'$(hostname)']\n/' | sed '$s/$/\n[log_end]/'
    write_log 'Failed!'
    if [[ -n $EXIT_FLAG ]]; then
        write_log 'Exiting!'
        rm $0
        exit 1
    fi
fi
}

function server_management_type_check() {
  write_log "Checking server management type"
  grep -q backup /etc/fstab && type=$FULLY_MANAGED || type=$MANAGED
  export MANAGEMENT_TYPE=$type
  write_log "Management type checked: $type"
}